#include <stdlib.h>
#include <stdio.h>
#include "structs.h"
#include "move.h"
#include "log.h"
#include "globals.h"


char move_msg[256];
location prev[20];
int search_depth;


void find_valid_moves(int player, int token, location start, int num, int call_num) {

    location temp;

    if (call_num == 0)  // on first call, there is no previous location
        prev[call_num] = start;

    if (board[start.y][start.x - 1] >= 0 && start.x - 1 != prev[call_num].x) {

        sprintf(move_msg, "token %d: start = (%d, %d), board[%d][%d] = %d, prev = (%d, %d).\n", token + 1, start.x, start.y, start.y, start.x - 1, board[start.y][start.x - 1], prev[call_num].x, prev[call_num].y);
        add_to_log(move_msg);
        if (num == 1) {

            if (board[start.y][start.x - 1] != player + 1) {

                temp.x = start.x - 1;
                temp.y = start.y;
                valid_moves[token][moves_count[token]] = temp;
                moves_count[token]++;
                sprintf(move_msg, "token %d: Added move %d (%d, %d) to list of valid moves.\n", token + 1, moves_count[token], temp.x, temp.y);
                add_to_log(move_msg);

            } // if (board[start.y][start.x - 1] != player)

        } // if (num == 1)
        else if (board[start.y][start.x - 1] != 9) {

            temp.x = start.x - 1;
            temp.y = start.y;
            prev[call_num + 1] = start;
            sprintf(move_msg, "token %d: Recursing to (%d, %d), %d moves left.\n", token + 1, temp.x, temp.y, num - 1);
            add_to_log(move_msg);
            find_valid_moves(player, token, temp, num - 1, call_num + 1);

        } // if (board[start.y][start.x - 1] != 9)

    } // if (board[start.y][start.x - 1] >= 0 && start.x - 1 != prev[call_num].x) {

    if (board[start.y][start.x + 1] >= 0 && start.x + 1 != prev[call_num].x) {

        sprintf(move_msg, "token %d: start = (%d, %d), board[%d][%d] = %d, prev = (%d, %d).\n", token + 1, start.x, start.y, start.y, start.x + 1, board[start.y][start.x + 1], prev[call_num].x, prev[call_num].y);
        add_to_log(move_msg);
        if (num == 1) {

            if (board[start.y][start.x + 1] != player + 1) {

                temp.x = start.x + 1;
                temp.y = start.y;
                valid_moves[token][moves_count[token]] = temp;
                moves_count[token]++;
                sprintf(move_msg, "token %d: Added move %d (%d, %d) to list of valid moves.\n", token + 1, moves_count[token], temp.x, temp.y);
                add_to_log(move_msg);

            } // if (board[start.y][start.x + 1] != player)

        } // if (num == 1)
        else if (board[start.y][start.x + 1] != 9) {

            temp.x = start.x + 1;
            temp.y = start.y;
            prev[call_num + 1] = start;
            sprintf(move_msg, "token %d: Recursing to (%d, %d), %d moves left.\n", token + 1, temp.x, temp.y, num - 1);
            add_to_log(move_msg);
            find_valid_moves(player, token, temp, num - 1, call_num + 1);

        } // if (board[start.y][start.x + 1] != 9)

    } // if (board[start.y][start.x + 1] >= 0 && start.x + 1 != prev[call_num].x)

    if (board[start.y - 1][start.x] >= 0 && start.y - 1!= prev[call_num].y) {

        sprintf(move_msg, "token %d: start = (%d, %d), board[%d][%d] = %d, prev = (%d, %d).\n", token + 1, start.x, start.y, start.y - 1, start.x, board[start.y - 1][start.x], prev[call_num].x, prev[call_num].y);
        add_to_log(move_msg);
        if (num == 1) {

            if (board[start.y - 1][start.x] != player + 1) {

                temp.x = start.x;
                temp.y = start.y - 1;
                valid_moves[token][moves_count[token]] = temp;
                moves_count[token]++;
                sprintf(move_msg, "token %d: Added move %d (%d, %d) to list of valid moves.\n", token + 1, moves_count[token], temp.x, temp.y);
                add_to_log(move_msg);

            } // if (board[start.y - 1][start.x] != player)

        } // if (num == 1)
        else if (board[start.y - 1][start.x] != 9) {

            temp.x = start.x;
            temp.y = start.y - 1;
            prev[call_num + 1] = start;
            sprintf(move_msg, "token %d: Recursing to (%d, %d), %d moves left.\n", token + 1, temp.x, temp.y, num - 1);
            add_to_log(move_msg);
            find_valid_moves(player, token, temp, num - 1, call_num + 1);

        } // if (board[start.y - 1][start.x] != 9)

    } // if (board[start.y - 1][start.x] >= 0 && start.y - 1!= prev[call_num].y)

    if (board[start.y + 1][start.x] >= 0 && start.y + 1 != prev[call_num].y && start.y < 14) {

        sprintf(move_msg, "token %d: start = (%d, %d), board[%d][%d] = %d, prev = (%d, %d).\n", token + 1, start.x, start.y, start.y + 1, start.x, board[start.y + 1][start.x], prev[call_num].x, prev[call_num].y);
        add_to_log(move_msg);
        if (num == 1) {

            if (board[start.y + 1][start.x] != player + 1) {

                temp.x = start.x;
                temp.y = start.y + 1;
                valid_moves[token][moves_count[token]] = temp;
                moves_count[token]++;
                sprintf(move_msg, "token %d: Added move %d (%d, %d) to list of valid moves.\n", token + 1, moves_count[token], temp.x, temp.y);
                add_to_log(move_msg);

            } // if (board[start.y + 1][start.x] != player)

        } //  if (num == 1)
        else if (board[start.y + 1][start.x] != 9) {

            temp.x = start.x;
            temp.y = start.y + 1;
            prev[call_num + 1] = start;
            sprintf(move_msg, "token %d: Recursing to (%d, %d), %d moves left.\n", token + 1, temp.x, temp.y, num - 1);
            add_to_log(move_msg);
            find_valid_moves(player, token, temp, num - 1, call_num + 1);

        } // if (board[start.y + 1][start.x] != 9)

    } // if (board[start.y + 1][start.x] >= 0 && start.y + 1 != prev[call_num].y)

}

